## mbedtls 2.28.6

=== debian/changelog ===
mbedtls (2.28.6-1ubuntu1) noble; urgency=medium

  * Fix ppc64el build failure with upstream-proposed patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 27 Dec 2023 16:18:21 +0100

mbedtls (2.28.6-1) unstable; urgency=medium

  * New upstream version 2.28.6
  * d/copyright: now available under Apache-2.0 or GPL-2+
  * d/copyright: update debian/ copyright information

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 20 Nov 2023 09:34:09 +0100

mbedtls (2.28.5-1) unstable; urgency=medium

  * Team upload.
  * debian/control: Update URL to use team's git
  * New upstream version 2.28.5
  * debian/libmbedcrypto7.symbols: Fix symbols for lintian

 -- Philippe Coval <rzr@users.sf.net>  Wed, 11 Oct 2023 19:57:04 +0200

mbedtls (2.28.4-1) unstable; urgency=medium

  * New upstream version 2.28.4
  * d/control: switch ownership to the Debian IoT Team

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 18 Aug 2023 11:41:40 +0200

## mbedtls 2.28.8

=== docs/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.9
# by the following command:
#
#    pip-compile requirements.in
#
alabaster==0.7.13
    # via sphinx
babel==2.12.1
    # via sphinx
breathe==4.35.0
    # via -r requirements.in
certifi==2022.12.7
    # via requests
charset-normalizer==3.1.0
    # via requests
docutils==0.17.1
    # via
    #   breathe
    #   sphinx
    #   sphinx-rtd-theme
idna==3.4
    # via requests
imagesize==1.4.1
    # via sphinx
importlib-metadata==6.0.0
    # via sphinx
jinja2==3.1.2
    # via sphinx
markupsafe==2.1.2
    # via jinja2
packaging==23.0
    # via sphinx
pygments==2.14.0
    # via sphinx
requests==2.28.2
    # via sphinx
snowballstemmer==2.2.0
    # via sphinx
sphinx==4.5.0
    # via
    #   breathe
    #   sphinx-rtd-theme
sphinx-rtd-theme==1.2.0
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.4
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.1
    # via sphinx
sphinxcontrib-jquery==2.0.0
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
urllib3==1.26.15
    # via requests
zipp==3.15.0
    # via importlib-metadata

# The following packages are considered to be unsafe in a requirements file:
# setuptools

=== library/CMakeLists.txt ===
option(USE_STATIC_MBEDTLS_LIBRARY "Build Mbed TLS static library." ON)
option(USE_SHARED_MBEDTLS_LIBRARY "Build Mbed TLS shared library." OFF)
option(LINK_WITH_PTHREAD "Explicitly link Mbed TLS library to pthread." OFF)
option(LINK_WITH_TRUSTED_STORAGE "Explicitly link Mbed TLS library to trusted_storage." OFF)

# Set the project root directory if it's not already defined, as may happen if
# the library folder is included directly by a parent project, without
# including the top level CMakeLists.txt.
if(NOT DEFINED MBEDTLS_DIR)
    set(MBEDTLS_DIR ${CMAKE_SOURCE_DIR})
endif()

set(src_crypto
    aes.c
    aesni.c
    arc4.c
    aria.c
    asn1parse.c
    asn1write.c
    base64.c
    bignum.c
    blowfish.c
    camellia.c
    ccm.c
    chacha20.c
    chachapoly.c
    cipher.c
    cipher_wrap.c
    constant_time.c
    cmac.c
    ctr_drbg.c
    des.c
    dhm.c
    ecdh.c
    ecdsa.c
    ecjpake.c
    ecp.c
    ecp_curves.c
    entropy.c
    entropy_poll.c
    error.c
    gcm.c
    havege.c
    hkdf.c
    hmac_drbg.c
    md.c
    md2.c
    md4.c
    md5.c
    memory_buffer_alloc.c
    mps_reader.c
    mps_trace.c
    nist_kw.c
    oid.c
    padlock.c
    pem.c
    pk.c
    pk_wrap.c
    pkcs12.c
    pkcs5.c
    pkparse.c
    pkwrite.c
    platform.c
    platform_util.c
    poly1305.c
    psa_crypto.c
    psa_crypto_aead.c
    psa_crypto_cipher.c
    psa_crypto_client.c
    psa_crypto_driver_wrappers.c
    psa_crypto_ecp.c
    psa_crypto_hash.c
    psa_crypto_mac.c
    psa_crypto_rsa.c
    psa_crypto_se.c
    psa_crypto_slot_management.c
    psa_crypto_storage.c
    psa_its_file.c
    ripemd160.c
    rsa.c
    rsa_internal.c
    sha1.c
    sha256.c
    sha512.c
    threading.c
    timing.c
    version.c
    version_features.c
    xtea.c
)

list(APPEND src_crypto ${thirdparty_src})

set(src_x509
    certs.c
    pkcs11.c
    x509.c
    x509_create.c
    x509_crl.c
    x509_crt.c
    x509_csr.c
    x509write_crt.c
    x509write_csr.c
)

set(src_tls
    debug.c
    net_sockets.c
    ssl_cache.c
    ssl_ciphersuites.c
    ssl_cli.c
    ssl_cookie.c
    ssl_msg.c
    ssl_srv.c
    ssl_ticket.c
    ssl_tls.c
    ssl_tls13_keys.c
)

if(CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-declarations -Wmissing-prototypes")
endif(CMAKE_COMPILER_IS_GNUCC)

if(CMAKE_COMPILER_IS_CLANG)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-declarations -Wmissing-prototypes -Wdocumentation -Wno-documentation-deprecated-sync -Wunreachable-code")
endif(CMAKE_COMPILER_IS_CLANG)

if(WIN32)
    set(libs ${libs} ws2_32)
endif(WIN32)

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    SET(CMAKE_C_ARCHIVE_CREATE   "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
    SET(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
    SET(CMAKE_C_ARCHIVE_FINISH   "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
    SET(CMAKE_CXX_ARCHIVE_FINISH "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
endif()

if(HAIKU)
    set(libs ${libs} network)
endif(HAIKU)

if(USE_PKCS11_HELPER_LIBRARY)
    set(libs ${libs} pkcs11-helper)
endif(USE_PKCS11_HELPER_LIBRARY)

if(ENABLE_ZLIB_SUPPORT)
    set(libs ${libs} ${ZLIB_LIBRARIES})
endif(ENABLE_ZLIB_SUPPORT)

if(LINK_WITH_PTHREAD)
    set(libs ${libs} pthread)
endif()

if(LINK_WITH_TRUSTED_STORAGE)
    set(libs ${libs} trusted_storage)
endif()

if (NOT USE_STATIC_MBEDTLS_LIBRARY AND NOT USE_SHARED_MBEDTLS_LIBRARY)
    message(FATAL_ERROR "Need to choose static or shared mbedtls build!")
endif(NOT USE_STATIC_MBEDTLS_LIBRARY AND NOT USE_SHARED_MBEDTLS_LIBRARY)

set(mbedtls_target    "${MBEDTLS_TARGET_PREFIX}mbedtls")
set(mbedx509_target   "${MBEDTLS_TARGET_PREFIX}mbedx509")
set(mbedcrypto_target "${MBEDTLS_TARGET_PREFIX}mbedcrypto")

set(mbedtls_target    ${mbedtls_target}    PARENT_SCOPE)
set(mbedx509_target   ${mbedx509_target}   PARENT_SCOPE)
set(mbedcrypto_target ${mbedcrypto_target} PARENT_SCOPE)

if (USE_STATIC_MBEDTLS_LIBRARY)
    set(mbedtls_static_target    ${mbedtls_target})
    set(mbedx509_static_target   ${mbedx509_target})
    set(mbedcrypto_static_target ${mbedcrypto_target})
endif()

set(target_libraries ${mbedcrypto_target} ${mbedx509_target} ${mbedtls_target})

if(USE_STATIC_MBEDTLS_LIBRARY AND USE_SHARED_MBEDTLS_LIBRARY)
    string(APPEND mbedtls_static_target    "_static")
    string(APPEND mbedx509_static_target   "_static")
    string(APPEND mbedcrypto_static_target "_static")

    list(APPEND target_libraries
        ${mbedcrypto_static_target}
        ${mbedx509_static_target}
        ${mbedtls_static_target})
endif()

if(USE_STATIC_MBEDTLS_LIBRARY)
    add_library(${mbedcrypto_static_target} STATIC ${src_crypto})
    set_target_properties(${mbedcrypto_static_target} PROPERTIES OUTPUT_NAME mbedcrypto)
    target_link_libraries(${mbedcrypto_static_target} PUBLIC ${libs})

    add_library(${mbedx509_static_target} STATIC ${src_x509})
    set_target_properties(${mbedx509_static_target} PROPERTIES OUTPUT_NAME mbedx509)
    target_link_libraries(${mbedx509_static_target} PUBLIC ${libs} ${mbedcrypto_static_target})

    add_library(${mbedtls_static_target} STATIC ${src_tls})
    set_target_properties(${mbedtls_static_target} PROPERTIES OUTPUT_NAME mbedtls)
    target_link_libraries(${mbedtls_static_target} PUBLIC ${libs} ${mbedx509_static_target})
endif(USE_STATIC_MBEDTLS_LIBRARY)

if(USE_SHARED_MBEDTLS_LIBRARY)
    set(CMAKE_LIBRARY_PATH ${CMAKE_CURRENT_BINARY_DIR})
    add_library(${mbedcrypto_target} SHARED ${src_crypto})
    set_target_properties(${mbedcrypto_target} PROPERTIES VERSION 2.28.8 SOVERSION 7)
    target_link_libraries(${mbedcrypto_target} PUBLIC ${libs})

    add_library(${mbedx509_target} SHARED ${src_x509})
    set_target_properties(${mbedx509_target} PROPERTIES VERSION 2.28.8 SOVERSION 1)
    target_link_libraries(${mbedx509_target} PUBLIC ${libs} ${mbedcrypto_target})

    add_library(${mbedtls_target} SHARED ${src_tls})
    set_target_properties(${mbedtls_target} PROPERTIES VERSION 2.28.8 SOVERSION 14)
    target_link_libraries(${mbedtls_target} PUBLIC ${libs} ${mbedx509_target})
endif(USE_SHARED_MBEDTLS_LIBRARY)

foreach(target IN LISTS target_libraries)
    # Include public header files from /include and other directories
    # declared by /3rdparty/**/CMakeLists.txt. Include private header files
    # from /library and others declared by /3rdparty/**/CMakeLists.txt.
    # /library needs to be listed explicitly when building .c files outside
    # of /library (which currently means: under /3rdparty).
    target_include_directories(${target}
        PUBLIC ${MBEDTLS_DIR}/include/
        PUBLIC ${thirdparty_inc_public}
        PRIVATE ${MBEDTLS_DIR}/library/
        PRIVATE ${thirdparty_inc}
        # Needed to include psa_crypto_driver_wrappers.h
        ${CMAKE_CURRENT_BINARY_DIR})
    target_compile_definitions(${target}
        PRIVATE ${thirdparty_def})
    # Pass-through MBEDTLS_CONFIG_FILE and MBEDTLS_USER_CONFIG_FILE
    if(MBEDTLS_CONFIG_FILE)
        target_compile_definitions(${target}
            PUBLIC MBEDTLS_CONFIG_FILE="${MBEDTLS_CONFIG_FILE}")
    endif()
    if(MBEDTLS_USER_CONFIG_FILE)
        target_compile_definitions(${target}
            PUBLIC MBEDTLS_USER_CONFIG_FILE="${MBEDTLS_USER_CONFIG_FILE}")
    endif()
    install(TARGETS ${target}
            DESTINATION ${CMAKE_INSTALL_LIBDIR}
            PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)
endforeach(target)

set(lib_target "${MBEDTLS_TARGET_PREFIX}lib")

add_custom_target(${lib_target} DEPENDS ${mbedcrypto_target} ${mbedx509_target} ${mbedtls_target})
if(USE_STATIC_MBEDTLS_LIBRARY AND USE_SHARED_MBEDTLS_LIBRARY)
    add_dependencies(${lib_target} ${mbedcrypto_static_target} ${mbedx509_static_target} ${mbedtls_static_target})
endif()

=== pkgconfig/CMakeLists.txt ===
if(NOT DISABLE_PACKAGE_CONFIG_AND_INSTALL)
  include(JoinPaths.cmake)
  join_paths(PKGCONFIG_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
  join_paths(PKGCONFIG_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")

  #define these manually since minimum CMAKE version is not 3.9 for DESCRIPTION and 3.12 for HOMEPAGE_URL usage in project() below.
  # Prefix with something that won't clash with newer versions of CMAKE.
  set(PKGCONFIG_PROJECT_DESCRIPTION "Mbed TLS is a C library that implements cryptographic primitives, X.509 certificate manipulation and the SSL/TLS and DTLS protocols. Its small code footprint makes it suitable for embedded systems.")
  set(PKGCONFIG_PROJECT_HOMEPAGE_URL "https://www.trustedfirmware.org/projects/mbed-tls/")

  # Following the conventsion for DESCRIPTION and HOMEPAGE_URL, VERSION wasn't added until 3.0 and depends on policy CMP0048
  set(PKGCONFIG_VERSION 2.28.8)

  configure_file(mbedcrypto.pc.in mbedcrypto.pc @ONLY)
    install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/mbedcrypto.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

  configure_file(mbedtls.pc.in mbedtls.pc @ONLY)
    install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/mbedtls.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

  configure_file(mbedx509.pc.in mbedx509.pc @ONLY)
    install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/mbedx509.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
endif()

=== programs/random/CMakeLists.txt ===
set(executables
    gen_entropy
    gen_random_ctr_drbg
    gen_random_havege
)

foreach(exe IN LISTS executables)
    add_executable(${exe} ${exe}.c $<TARGET_OBJECTS:mbedtls_test>)
    target_link_libraries(${exe} ${mbedcrypto_target})
endforeach()

install(TARGETS ${executables}
        DESTINATION "bin"
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

=== tests/data_files/Makefile ===
## This file contains a record of how some of the test data was
## generated. The final build products are committed to the repository
## as well to make sure that the test data is identical. You do not
## need to use this makefile unless you're extending Mbed TLS's tests.

## Many data files were generated prior to the existence of this
## makefile, so the method of their generation was not recorded.

## Note that in addition to depending on the version of the data
## generation tool, many of the build outputs are randomized, so
## running this makefile twice would not produce the same results.

## Tools
OPENSSL ?= openssl
FAKETIME ?= faketime

TOP_DIR = ../..
MBEDTLS_CERT_WRITE ?= $(TOP_DIR)/programs/x509/cert_write
MBEDTLS_CERT_REQ ?= $(TOP_DIR)/programs/x509/cert_req


## Build the generated test data. Note that since the final outputs
## are committed to the repository, this target should do nothing on a
## fresh checkout. Furthermore, since the generation is randomized,
## re-running the same targets may result in differing files. The goal
## of this makefile is primarily to serve as a record of how the
## targets were generated in the first place.
default: all_final

all_intermediate := # temporary files
all_final := # files used by tests



################################################################
#### Generate certificates from existing keys
################################################################

test_ca_crt = test-ca.crt
test_ca_key_file_rsa = test-ca.key
test_ca_pwd_rsa = PolarSSLTest
test_ca_config_file = test-ca.opensslconf

$(test_ca_key_file_rsa):
	$(OPENSSL) genrsa -aes-128-cbc -passout pass:$(test_ca_pwd_rsa) -out $@ 2048
all_final += $(test_ca_key_file_rsa)

test-ca.req.sha256: $(test_ca_key_file_rsa)
	$(MBEDTLS_CERT_REQ) output_file=$@ filename=$(test_ca_key_file_rsa) password=$(test_ca_pwd_rsa) subject_name="C=NL,O=PolarSSL,CN=PolarSSL Test CA" md=SHA256
all_intermediate += test-ca.req.sha256

test-ca.crt: $(test_ca_key_file_rsa) test-ca.req.sha256
	$(MBEDTLS_CERT_WRITE) is_ca=1 serial=3 request_file=test-ca.req.sha256 selfsign=1 issuer_name="C=NL,O=PolarSSL,CN=PolarSSL Test CA" issuer_key=$(test_ca_key_file_rsa) issuer_pwd=$(test_ca_pwd_rsa) not_before=20190210144400 not_after=20290210144400 md=SHA1 version=3 output_file=$@
all_final += test-ca.crt

test-ca.crt.der: test-ca.crt
	$(OPENSSL) x509 -inform PEM -in $< -outform DER -out $@
all_final += test-ca.crt.der

test-ca.key.der: $(test_ca_key_file_rsa)
	$(OPENSSL) pkey -in $< -out $@ -inform PEM -outform DER -passin "pass:$(test_ca_pwd_rsa)"
all_final += test-ca.key.der

# This is only used for generating cert_example_multi_nocn.crt
test-ca_nocn.crt: $(test_ca_key_file_rsa)
	$(MBEDTLS_CERT_WRITE) is_ca=1 serial=3 selfsign=1 \
		subject_key=$(test_ca_key_file_rsa) subject_pwd=$(test_ca_pwd_rsa)  subject_name="C=NL" \
		issuer_key=$(test_ca_key_file_rsa) issuer_pwd=$(test_ca_pwd_rsa) issuer_name="C=NL" \
		not_before=20190210144400 not_after=20290210144400 md=SHA1 version=3 output_file=$@
all_intermediate += test-ca_nocn.crt

test-ca-sha1.crt: $(test_ca_key_file_rsa) test-ca.req.sha256
	$(MBEDTLS_CERT_WRITE) is_ca=1 serial=3 request_file=test-ca.req.sha256 selfsign=1 issuer_name="C=NL,O=PolarSSL,CN=PolarSSL Test CA" issuer_key=$(test_ca_key_file_rsa) issuer_pwd=$(test_ca_pwd_rsa) not_before=20190210144400 not_after=20290210144400 md=SHA1 version=3 output_file=$@
all_final += test-ca-sha1.crt

test-ca-sha1.crt.der: test-ca-sha1.crt
	$(OPENSSL) x509 -in $< -out $@ -inform PEM -outform DER
all_final += test-ca-sha1.crt.der

test-ca-sha256.crt: $(test_ca_key_file_rsa) test-ca.req.sha256
	$(MBEDTLS_CERT_WRITE) is_ca=1 serial=3 request_file=test-ca.req.sha256 selfsign=1 issuer_name="C=NL,O=PolarSSL,CN=PolarSSL Test CA" issuer_key=$(test_ca_key_file_rsa) issuer_pwd=$(test_ca_pwd_rsa) not_before=20190210144400 not_after=20290210144400 md=SHA256 version=3 output_file=$@
all_final += test-ca-sha256.crt

test-ca-sha256.crt.der: test-ca-sha256.crt
	$(OPENSSL) x509 -in $< -out $@ -inform PEM -outform DER
all_final += test-ca-sha256.crt.der

test-ca_utf8.crt: $(test_ca_key_file_rsa)
	$(OPENSSL) req -x509 -new -nodes -key $(test_ca_key_file_rsa) -passin "pass:$(test_ca_pwd_rsa)" -set_serial 3 -config $(test_ca_config_file) -sha1 -days 3653 -utf8 -subj "/C=NL/O=PolarSSL/CN=PolarSSL Test CA" -out $@
all_final += test-ca_utf8.crt

test-ca_printable.crt: $(test_ca_key_file_rsa)
	$(OPENSSL) req -x509 -new -nodes -key $(test_ca_key_file_rsa) -passin "pass:$(test_ca_pwd_rsa)" -set_serial 3 -config $(test_ca_config_file) -sha1 -days 3653 -subj "/C=NL/O=PolarSSL/CN=PolarSSL Test CA" -out $@
all_final += test-ca_printable.crt

test-ca_uppercase.crt: $(test_ca_key_file_rsa)
	$(OPENSSL) req -x509 -new -nodes -key $(test_ca_key_file_rsa) -passin "pass:$(test_ca_pwd_rsa)" -set_serial 3 -config $(test_ca_config_file) -sha1 -days 3653 -subj "/C=NL/O=PolarSSL/CN=PolarSSL Test CA" -out $@
all_final += test-ca_uppercase.crt

test_ca_key_file_rsa_alt = test-ca-alt.key

cert_example_multi.csr: rsa_pkcs1_1024_clear.pem
	$(OPENSSL) req -new -subj "/C=NL/O=PolarSSL/CN=www.example.com" -set_serial 17 -config $(test_ca_config_file) -extensions dns_alt_names -days 3650 -key rsa_pkcs1_1024_clear.pem -out $@

cert_example_multi.crt: cert_example_multi.csr
	$(OPENSSL) x509 -req -CA $(test_ca_crt) -CAkey $(test_ca_key_file_rsa) -extfile $(test_ca_config_file) -extensions dns_alt_names -passin "pass:$(test_ca_pwd_rsa)" -set_serial 17 -days 3653 -sha256 -in $< > $@

cert_example_multi_nocn.csr: rsa_pkcs1_1024_clear.pem
	$(MBEDTLS_CERT_REQ) filename=$< output_file=$@ subject_name='C=NL'
all_intermediate += cert_example_multi_nocn.csr

cert_example_multi_nocn.crt: cert_example_multi_nocn.csr test-ca_nocn.crt
	$(OPENSSL) x509 -req -CA test-ca_nocn.crt -CAkey $(test_ca_key_file_rsa) \
		-extfile $(test_ca_config_file) -extensions ext_multi_nocn -passin "pass:$(test_ca_pwd_rsa)" \
		-set_serial  0xf7c67ff8e9a963f9 -days 3653 -sha1 -in $< > $@
all_final += cert_example_multi_nocn.crt

$(test_ca_key_file_rsa_alt):test-ca.opensslconf
	$(OPENSSL) genrsa -out $@ 2048
test-ca-alt.csr: $(test_ca_key_file_rsa_alt) $(test_ca_config_file)
	$(OPENSSL) req -new -config $(test_ca_config_file) -key $(test_ca_key_file_rsa_alt) -subj "/C=NL/O=PolarSSL/CN=PolarSSL Test CA" -out $@
all_intermediate += test-ca-alt.csr
test-ca-alt.crt: $(test_ca_key_file_rsa_alt) $(test_ca_config_file) test-ca-alt.csr
	$(OPENSSL) req -x509 -config $(test_ca_config_file) -key $(test_ca_key_file_rsa_alt) -set_serial 0 -days 3653 -sha256 -in test-ca-alt.csr -out $@
all_final += test-ca-alt.crt
test-ca-alt-good.crt: test-ca-alt.crt test-ca-sha256.crt
	cat test-ca-alt.crt test-ca-sha256.crt > $@
all_final += test-ca-alt-good.crt
test-ca-good-alt.crt: test-ca-alt.crt test-ca-sha256.crt
	cat test-ca-sha256.crt test-ca-alt.crt > $@
all_final += test-ca-good-alt.crt

test_ca_crt_file_ec = test-ca2.crt
test_ca_key_file_ec = test-ca2.key

test-ca2.req.sha256: $(test_ca_key_file_ec)
	$(MBEDTLS_CERT_REQ) output_file=$@ filename=$(test_ca_key_file_ec) \
	subject_name="C=NL,O=PolarSSL,CN=Polarssl Test EC CA" md=SHA256
all_intermediate += test-ca2.req.sha256

test-ca2.crt: $(test_ca_key_file_ec) test-ca2.req.sha256
	$(MBEDTLS_CERT_WRITE) is_ca=1 serial=13926223505202072808 selfsign=1 \
		request_file=test-ca2.req.sha256 \
		issuer_name="C=NL,O=PolarSSL,CN=Polarssl Test EC CA" \
		issuer_key=$(test_ca_key_file_ec) \
		not_before=20190210144400 not_after=20290210144400 \
		md=SHA256 version=3 output_file=$@
all_final += test-ca2.crt

test-ca2.ku-%.crt: test-ca2.ku-%.crt.openssl.v3_ext $(test_ca_key_file_ec) test-ca2.req.sha256
	$(OPENSSL) x509 -req -in test-ca2.req.sha256 -extfile $< \
		-signkey $(test_ca_key_file_ec) -days 3653 -out $@

all_final += test-ca2.ku-crl.crt test-ca2.ku-crt.crt test-ca2.ku-crt_crl.crt \
	     test-ca2.ku-ds.crt

test-ca2-future.crt: $(test_ca_key_file_ec) test-ca2.req.sha256
	$(MBEDTLS_CERT_WRITE) is_ca=1 serial=13926223505202072808 request_file=test-ca2.req.sha256 selfsign=1 \
		issuer_name="C=NL,O=PolarSSL,CN=Polarssl Test EC CA" issuer_key=$(test_ca_key_file_ec) \
		not_before=20290210144400 not_after=20390210144400 md=SHA256 version=3 output_file=$@
all_intermediate += test-ca2-future.crt

test_ca_ec_cat := # files that concatenate different crt
test-ca2_cat-future-invalid.crt: test-ca2-future.crt server6.crt
test_ca_ec_cat += test-ca2_cat-future-invalid.crt
test-ca2_cat-future-present.crt: test-ca2-future.crt test-ca2.crt
test_ca_ec_cat += test-ca2_cat-future-present.crt
test-ca2_cat-present-future.crt: test-ca2.crt test-ca2-future.crt
test_ca_ec_cat += test-ca2_cat-present-future.crt
test-ca2_cat-present-past.crt: test-ca2.crt test-ca2-expired.crt
test_ca_ec_cat += test-ca2_cat-present-past.crt
test-ca2_cat-past-invalid.crt: test-ca2-expired.crt server6.crt
test_ca_ec_cat += test-ca2_cat-past-invalid.crt
test-ca2_cat-past-present.crt: test-ca2-expired.crt test-ca2.crt
test_ca_ec_cat += test-ca2_cat-past-present.crt
$(test_ca_ec_cat):
	cat $^ > $@
all_final += $(test_ca_ec_cat)

test-ca-any_policy.crt: $(test_ca_key_file_rsa) test-ca.req.sha256
	$(OPENSSL) req -x509 -config $(test_ca_config_file) -extensions v3_any_policy_ca \
		-key $(test_ca_key_file_rsa) -passin "pass:$(test_ca_pwd_rsa)" \
		-set_serial 0 -days 3653 -sha256 -in test-ca.req.sha256 -out $@
all_final += test-ca-any_policy.crt

test-ca-any_policy_ec.crt: $(test_ca_key_file_ec) test-ca.req_ec.sha256
	$(OPENSSL) req -x509 -config $(test_ca_config_file) -extensions v3_any_policy_ca \
		-key $(test_ca_key_file_ec) -set_serial 0 -days 3653 -sha256 \
		-in test-ca.req_ec.sha256 -out $@
all_final += test-ca-any_policy_ec.crt

test-ca-any_policy_with_qualifier.crt: $(test_ca_key_file_rsa) test-ca.req.sha256
	$(OPENSSL) req -x509 -config $(test_ca_config_file) -extensions v3_any_policy_qualifier_ca -key $(test_ca_key_file_rsa) -passin "pass:$(test_ca_pwd_rsa)" -set_serial 0 -days 3653 -sha256 -in test-ca.req.sha256 -out $@
all_final += test-ca-any_policy_with_qualifier.crt

test-ca-any_policy_with_qualifier_ec.crt: $(test_ca_key_file_ec) test-ca.req_ec.sha256
	$(OPENSSL) req -x509 -config $(test_ca_config_file) -extensions v3_any_policy_qualifier_ca -key $(test_ca_key_file_ec) -set_serial 0 -days 3653 -sha256 -in test-ca.req_ec.sha256 -out $@
all_final += test-ca-any_policy_with_qualifier_ec.crt

test-ca-multi_policy.crt: $(test_ca_key_file_rsa) test-ca.req.sha256
	$(OPENSSL) req -x509 -config $(test_ca_config_file) -extensions v3_multi_policy_ca -key $(test_ca_key_file_rsa) -passin "pass:$(test_ca_pwd_rsa)" -set_serial 0 -days 3653 -sha256 -in test-ca.req.sha256 -out $@
all_final += test-ca-multi_policy.crt

test-ca-multi_policy_ec.crt: $(test_ca_key_file_ec) test-ca.req_ec.sha256
	$(OPENSSL) req -x509 -config $(test_ca_config_file) -extensions v3_multi_policy_ca -key $(test_ca_key_file_ec) -set_serial 0 -days 3653 -sha256 -in test-ca.req_ec.sha256 -out $@
all_final += test-ca-multi_policy_ec.crt

test-ca-unsupported_policy.crt: $(test_ca_key_file_rsa) test-ca.req.sha256
	$(OPENSSL) req -x509 -config $(test_ca_config_file) -extensions v3_unsupported_policy_ca -key $(test_ca_key_file_rsa) -passin "pass:$(test_ca_pwd_rsa)" -set_serial 0 -days 3653 -sha256 -in test-ca.req.sha256 -out $@
all_final += test-ca-unsupported_policy.crt

test-ca-unsupported_policy_ec.crt: $(test_ca_key_file_ec) test-ca.req_ec.sha256
	$(OPENSSL) req -x509 -config $(test_ca_config_file) -extensions v3_unsupported_policy_ca -key $(test_ca_key_file_ec) -set_serial 0 -days 3653 -sha256 -in test-ca.req_ec.sha256 -out $@
all_final += test-ca-unsupported_policy_ec.crt

test-ca.req_ec.sha256: $(test_ca_key_file_ec)
	$(MBEDTLS_CERT_REQ) output_file=$@ filename=$(test_ca_key_file_ec) subject_name="C=NL, O=PolarSSL, CN=Polarssl Test EC CA" md=SHA256
all_intermediate += test-ca.req_ec.sha256

test-ca2.crt.der: $(test_ca_crt_file_ec)
	$(OPENSSL) x509 -in $(test_ca_crt_file_ec) -out $@ -inform PEM -outform DER

=== debian/changelog ===
mbedtls (2.28.8-1deepin1) unstable; urgency=medium

  * Revert t64.

 -- xiangzelong <xiangzelong@deepin.org>  Sat, 14 Sep 2024 09:53:44 +0800

mbedtls (2.28.8-1) unstable; urgency=medium

  * New upstream version 2.28.8
  * d/libmbedtls-dev.install: install new pkg-config files (Closes: #900015)
  * d/.symbols: add new PSA symbols

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 31 Mar 2024 20:02:32 +0200

mbedtls (2.28.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062859

 -- Graham Inggs <ginggs@debian.org>  Thu, 29 Feb 2024 12:19:38 +0000

mbedtls (2.28.7-1) unstable; urgency=medium

  * New upstream version 2.28.7
    - Fixes CVE-2024-23170
    - Fixes CVE-2024-23775
  * d/libmbedcrypto7.symbols: add new MPI symbols

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 27 Jan 2024 13:12:37 +0100

=== debian/control ===
Source: mbedtls
Section: libs
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@alioth-lists.debian.net>
Uploaders: Andrea Pappacoda <andrea@pappacoda.it>
Standards-Version: 4.6.2
Build-Depends: dpkg-dev (>= 1.22.5), cmake, debhelper-compat (= 13)
Build-Depends-Arch: faketime <!nocheck>, python3:any
Build-Depends-Indep: doxygen <!nodoc>, graphviz <!nodoc>, python3
Rules-Requires-Root: no
Homepage: https://www.trustedfirmware.org/projects/mbed-tls/
Vcs-Git: https://salsa.debian.org/debian-iot-team/mbedtls.git
Vcs-Browser: https://salsa.debian.org/debian-iot-team/mbedtls

Package: libmbedtls-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libmbedcrypto7 (= ${binary:Version}),
 libmbedtls14 (= ${binary:Version}),
 libmbedx509-1 (= ${binary:Version}),
 ${misc:Depends}
Suggests: libmbedtls-doc
Description: lightweight crypto and SSL/TLS library - development files
 mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
 providing SSL and TLS support in your programs. It offers an intuitive API and
 documented header files, so you can actually understand what the code does.
 It features:
  - Symmetric algorithms, like AES, Blowfish, Triple-DES, DES, ARC4, Camellia
    and XTEA
  - Hash algorithms, like SHA-1, SHA-2, RIPEMD-160 and MD5
  - Entropy pool and random generators, like CTR-DRBG and HMAC-DRBG
  - Public key algorithms, like RSA, Elliptic Curves, Diffie-Hellman, ECDSA
    and ECDH
  - TLS 1.0, 1.1 and 1.2
  - Abstraction layers for ciphers, hashes, public key operations, platform
    abstraction and threading
 .
 This package contains the header files and static libraries for mbed TLS.

Package: libmbedcrypto7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight crypto and SSL/TLS library - crypto library
 mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
 providing SSL and TLS support in your programs. It offers an intuitive API and
 documented header files, so you can actually understand what the code does.
 It features:
  - Symmetric algorithms, like AES, Blowfish, Triple-DES, DES, ARC4, Camellia
    and XTEA
  - Hash algorithms, like SHA-1, SHA-2, RIPEMD-160 and MD5
  - Entropy pool and random generators, like CTR-DRBG and HMAC-DRBG
  - Public key algorithms, like RSA, Elliptic Curves, Diffie-Hellman, ECDSA
    and ECDH
  - TLS 1.0, 1.1 and 1.2
  - Abstraction layers for ciphers, hashes, public key operations, platform
    abstraction and threading
 .
 This package contains the shared library handling cryptography.

Package: libmbedtls14
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight crypto and SSL/TLS library - tls library
 mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
 providing SSL and TLS support in your programs. It offers an intuitive API and
 documented header files, so you can actually understand what the code does.
 It features:
  - Symmetric algorithms, like AES, Blowfish, Triple-DES, DES, ARC4, Camellia
    and XTEA
  - Hash algorithms, like SHA-1, SHA-2, RIPEMD-160 and MD5
  - Entropy pool and random generators, like CTR-DRBG and HMAC-DRBG
  - Public key algorithms, like RSA, Elliptic Curves, Diffie-Hellman, ECDSA
    and ECDH
  - TLS 1.0, 1.1 and 1.2
  - Abstraction layers for ciphers, hashes, public key operations, platform
    abstraction and threading
 .
 This package contains the shared library handling TLS.

Package: libmbedx509-1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight crypto and SSL/TLS library - x509 certificate library
 mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
 providing SSL and TLS support in your programs. It offers an intuitive API and
 documented header files, so you can actually understand what the code does.
 It features:
  - Symmetric algorithms, like AES, Blowfish, Triple-DES, DES, ARC4, Camellia
    and XTEA
  - Hash algorithms, like SHA-1, SHA-2, RIPEMD-160 and MD5
  - Entropy pool and random generators, like CTR-DRBG and HMAC-DRBG
  - Public key algorithms, like RSA, Elliptic Curves, Diffie-Hellman, ECDSA
    and ECDH
  - TLS 1.0, 1.1 and 1.2
  - Abstraction layers for ciphers, hashes, public key operations, platform
    abstraction and threading
 .
 This package contains the shared library handling x509 certificates.

Package: libmbedtls-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-jquery, ${misc:Depends}
Suggests: libmbedtls-dev
Description: lightweight crypto and SSL/TLS library - documentation
 mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
 providing SSL and TLS support in your programs. It offers an intuitive API and
 documented header files, so you can actually understand what the code does.
 It features:
  - Symmetric algorithms, like AES, Blowfish, Triple-DES, DES, ARC4, Camellia
    and XTEA
  - Hash algorithms, like SHA-1, SHA-2, RIPEMD-160 and MD5
  - Entropy pool and random generators, like CTR-DRBG and HMAC-DRBG
  - Public key algorithms, like RSA, Elliptic Curves, Diffie-Hellman, ECDSA
    and ECDH
  - TLS 1.0, 1.1 and 1.2
  - Abstraction layers for ciphers, hashes, public key operations, platform
    abstraction and threading
 .
 This package contains the API documentation.

=== debian/watch ===
version=4
#just show LTS updates
opts="searchmode=plain, \
  filenamemangle=s/.*v@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none" \
https://api.github.com/repos/Mbed-TLS/mbedtls/tags \
https://api.github.com/repos/Mbed-TLS/mbedtls/tarball/refs/tags/v(2\.28\.\d+)

#show all versions
#opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/mbedtls-$1\.tar\.gz/ \
#  https://github.com/Mbed-TLS/mbedtls/tags .*/v?(\d\S+)\.tar\.gz

## mbedtls 3.5.0

=== debian/changelog ===
mbedtls (3.5.0-1) UNRELEASED; urgency=medium

  * debian/control: Update URL to use team's git
  * New upstream version 2.28.5
  * debian/libmbedcrypto7.symbols: Fix symbols for lintian
  * New upstream version 3.5.0 (Closes: #1036231)
  * debian/watch: Use latest

 -- Philippe Coval <rzr@users.sf.net>  Mon, 09 Oct 2023 16:50:50 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@alioth-lists.debian.net>
 Uploaders: Andrea Pappacoda <andrea@pappacoda.it>
 Standards-Version: 4.6.2
-Build-Depends: dpkg-dev (>= 1.22.5), cmake, debhelper-compat (= 13)
+Build-Depends: cmake, debhelper-compat (= 13)
 Build-Depends-Arch: faketime <!nocheck>, python3:any
 Build-Depends-Indep: doxygen <!nodoc>, graphviz <!nodoc>, python3
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

# LTO is disabled until https://github.com/Mbed-TLS/mbedtls/issues/5906 is fixed
# optimize=-lto because I use CMake's LTO
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+all,-lto qa=+all
# Required as libmbedtls-dev ships .a files
#export DEB_CFLAGS_MAINT_APPEND   = -ffat-lto-objects
#export DEB_CXXFLAGS_MAINT_APPEND = -ffat-lto-objects

UPSTREAM_DATE = $(shell awk '/^= .* [0-9-]*$$/ { print $$NF; exit }' ChangeLog)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  test := true
else
  test := false
endif

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
  doc := true
else
  doc := false
endif

%:
	dh $@ --buildsystem=cmake

CONFIG_H = include/mbedtls/mbedtls_config.h

execute_after_dh_auto_clean:
	[ ! -e $(CONFIG_H).bak ] || mv $(CONFIG_H).bak $(CONFIG_H)

override_dh_auto_configure:
	cp $(CONFIG_H) $(CONFIG_H).bak
	scripts/config.py set MBEDTLS_DEPRECATED_WARNING
	scripts/config.py set MBEDTLS_THREADING_C
	scripts/config.py set MBEDTLS_THREADING_PTHREAD
	scripts/config.py set MBEDTLS_CMAC_C
	scripts/config.py set MBEDTLS_SSL_DTLS_SRTP
	dh_auto_configure -- \
		-DLIB_INSTALL_DIR="lib/$(DEB_HOST_MULTIARCH)" \
		-DUSE_STATIC_MBEDTLS_LIBRARY=ON \
		-DUSE_SHARED_MBEDTLS_LIBRARY=ON \
		-DENABLE_PROGRAMS=OFF \
		-DENABLE_TESTING=$(test) \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
#		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
#		-DCMAKE_POLICY_DEFAULT_CMP0069=NEW

ifeq ($(doc),true)
override_dh_auto_build-indep:
	dh_auto_build --indep -- apidoc
endif

# Use faketime to prevent testsuite timebombing in the future
override_dh_auto_test-arch:
	faketime '$(UPSTREAM_DATE)' dh_auto_test --no-parallel

override_dh_auto_test-indep:
override_dh_auto_install-indep:

ifeq ($(doc),true)
execute_after_dh_installdocs-indep:
	dh_doxygen --indep
endif

=== debian/watch ===
--- 
+++ 
@@ -4,7 +4,7 @@
   filenamemangle=s/.*v@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
   pgpmode=none" \
 https://api.github.com/repos/Mbed-TLS/mbedtls/tags \
-https://api.github.com/repos/Mbed-TLS/mbedtls/tarball/refs/tags/v(2\.28\.\d+)
+https://api.github.com/repos/Mbed-TLS/mbedtls/tarball/refs/tags/v(\d+.\d+\.\d+)
 
 #show all versions
 #opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/mbedtls-$1\.tar\.gz/ \
